/*    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package esrpatcher;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Iterator;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.SwingConstants;

import util.Utils;


public class DialogResult extends JDialog
{
    private static final long serialVersionUID = 1L;

    public DialogResult(Frame parent, List<File> files, List<ESRStatus> results)
    {
        super(parent, "Results");
        JRootPane rootPane = getRootPane();
        rootPane.setLayout(new BorderLayout());

        //rootPane.add(new JLabel("Results: ", SwingConstants.LEFT), BorderLayout.NORTH);

        JPanel resultPanel = new JPanel();
        resultPanel.setLayout(new GridBagLayout());
        GridBagConstraints constraint = new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0, GridBagConstraints.WEST,
                GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0);

        File currFile;
        ESRStatus currResult;
        JLabel currLabel;
        Iterator<File> filesIte = files.iterator();
        Iterator<ESRStatus> resultsIte = results.iterator();

        while (filesIte.hasNext())
        {
            currResult = resultsIte.next();
            currFile = filesIte.next();

            if (currResult != null)
            {
                if (constraint.gridy == 0)
                {

                }
                currLabel = new JLabel(currFile.getName() + " - " + currResult.getMessage(), currResult.getIcon(),
                        SwingConstants.LEFT);
                resultPanel.add(currLabel, constraint);
                constraint.gridy++;
            }
        }
        JScrollPane scrollPane = new JScrollPane(resultPanel);
        scrollPane.setViewportBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        rootPane.add(scrollPane, BorderLayout.CENTER);

        JButton okButton = new JButton("Ok");
        okButton.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent e)
            {
                DialogResult.this.setVisible(false);
                DialogResult.this.dispose();
            }
        });
        rootPane.add(okButton, BorderLayout.SOUTH);

        pack();

        Dimension maxSize = Utils.getDefaultSize();
        Dimension resultSize = resultPanel.getSize();
        Dimension finalSize = new Dimension(maxSize);

        if (resultSize.width < maxSize.width)
        {
            finalSize.width = resultSize.width + 60;
        }
        if (resultSize.height < maxSize.height)
        {
            finalSize.height = resultSize.height + 90;
        }

        setSize(finalSize);
        Utils.centerResizeWindow(this, false);
        setVisible(true);
        toFront();
    }
}
