package opl;

import static opl.RenderMan.ALIGN_NONE;
import static opl.RenderMan.DIM_INF;
import static opl.RenderMan.gDefaultCol;
import static opl.RenderMan.rmDrawPixmap;
import static opl.RenderMan.rmDrawRect;

import java.awt.Graphics;
import java.awt.Image;

import oplutil.Main;
import oplutil.device.MenuBase;

public class Gui
{
    public static void guiDrawBGColor(Main main, Graphics graphics, MenuBase menu)
    {
        rmDrawRect(graphics, 0, 0, ALIGN_NONE, DIM_INF, DIM_INF, main.getTheme().bgColor);
    }

    public static void guiDrawBGPicture(Main main, Graphics graphics, MenuBase menu)
    {
        Image backTex = main.getTheme().thmGetTexture(Textures.BACKGROUND_PICTURE);
        if (backTex != null)
        {
            rmDrawPixmap(graphics, backTex, 0, 0, ALIGN_NONE, DIM_INF, DIM_INF, gDefaultCol);
        }
        else
        {
            guiDrawBGPlasma(main, graphics, menu);
        }
    }

    public static void guiDrawBGArt(Main main, Graphics graphics, MenuBase menu)
    {
        Image someTex = MenuSys.menuGetCurrentArt(menu);
        if (someTex != null)
        {
            rmDrawPixmap(graphics, someTex, 0, 0, ALIGN_NONE, DIM_INF, DIM_INF, main.getTheme().itemCover.color);
        }
        else
        {
            guiDrawBGPicture(main, graphics, menu);
        }
    }

    public static void guiDrawBGPlasma(Main main, Graphics graphics, MenuBase menu)
    {
        // TODO: implement Plasma
        guiDrawBGColor(main, graphics, menu);
    }
}
