package opl;

public class OplSystem
{
    private static int crctab[] = new int[256];

    static
    {
        int crc = 0, table, count;

        for (table = 0; table < 256; table++)
        {
            crc = table << 24;

            for (count = 8; count > 0; count--)
            {
                if (crc < 0)
                {
                    crc = crc << 1;
                }
                else
                {
                    crc = (crc << 1) ^ 0x04C11DB7;
                }
            }
            crctab[255 - table] = crc;
        }
    }

    public static String USBA_crc32(String string)
    {
        int crc = 0, i = 0, len = string.length();
        for (; i < len; i++)
        {
            crc = crctab[string.charAt(i) ^ ((crc >> 24) & 0xFF)] ^ ((crc << 8) & 0xFFFFFF00);
        }
        crc = crctab[0 ^ ((crc >> 24) & 0xFF)] ^ ((crc << 8) & 0xFFFFFF00);

        return String.format("%08X", Integer.valueOf(crc));
    }
}
