package opl;

import java.awt.Image;

import util.Utils;

public class Textures
{
    public static final int LOAD0_ICON = 0;
    public static final int LOAD1_ICON = 1;
    public static final int LOAD2_ICON = 2;
    public static final int LOAD3_ICON = 3;
    public static final int LOAD4_ICON = 4;
    public static final int LOAD5_ICON = 5;
    public static final int LOAD6_ICON = 6;
    public static final int LOAD7_ICON = 7;
    public static final int EXIT_ICON = 8;
    public static final int CONFIG_ICON = 9;
    public static final int SAVE_ICON = 10;
    public static final int USB_ICON = 11;
    public static final int HDD_ICON = 12;
    public static final int ETH_ICON = 13;
    public static final int APP_ICON = 14;
    public static final int DISC_ICON = 15;
    public static final int LEFT_ICON = 16;
    public static final int RIGHT_ICON = 17;
    public static final int UP_ICON = 18;
    public static final int DOWN_ICON = 19;
    public static final int L1_ICON = 20;
    public static final int L2_ICON = 21;
    public static final int R1_ICON = 22;
    public static final int R2_ICON = 23;
    public static final int CROSS_ICON = 24;
    public static final int TRIANGLE_ICON = 25;
    public static final int CIRCLE_ICON = 26;
    public static final int SQUARE_ICON = 27;
    public static final int SELECT_ICON = 28;
    public static final int START_ICON = 29;
    public static final int COVER_OVERLAY = 30;
    public static final int BACKGROUND_PICTURE = 31;
    public static final int LOGO_PICTURE = 32;

    public static final int TEXTURES_COUNT = 33;

    
    public static Textures internalDefault[];

    private static void initTexture(int id, String name)
    {
        Textures tex = new Textures(id, name);
        internalDefault[id] = tex;

        tex.texture = texDiscoverLoad(null, id);
    }

    static
    {
        internalDefault = new Textures[TEXTURES_COUNT];

        initTexture(LOAD0_ICON, "load0");
        initTexture(LOAD1_ICON, "load1");
        initTexture(LOAD2_ICON, "load2");
        initTexture(LOAD3_ICON, "load3");
        initTexture(LOAD4_ICON, "load4");
        initTexture(LOAD5_ICON, "load5");
        initTexture(LOAD6_ICON, "load6");
        initTexture(LOAD7_ICON, "load7");
        initTexture(EXIT_ICON, "exit");
        initTexture(CONFIG_ICON, "config");
        initTexture(SAVE_ICON, "save");
        initTexture(USB_ICON, "usb");
        initTexture(HDD_ICON, "hdd");
        initTexture(ETH_ICON, "eth");
        initTexture(APP_ICON, "app");
        initTexture(DISC_ICON, "disc");
        initTexture(LEFT_ICON, "left");
        initTexture(RIGHT_ICON, "right");
        initTexture(UP_ICON, "up");
        initTexture(DOWN_ICON, "down");
        initTexture(L1_ICON, "L1");
        initTexture(L2_ICON, "L2");
        initTexture(R1_ICON, "R1");
        initTexture(R2_ICON, "R2");
        initTexture(CROSS_ICON, "cross");
        initTexture(TRIANGLE_ICON, "triangle");
        initTexture(CIRCLE_ICON, "circle");
        initTexture(SQUARE_ICON, "square");
        initTexture(SELECT_ICON, "select");
        initTexture(START_ICON, "start");
        initTexture(COVER_OVERLAY, "cover_overlay");
        initTexture(BACKGROUND_PICTURE, "background");
        initTexture(LOGO_PICTURE, "logo");
    }

    public static Image texDiscoverLoad(String path, int texId)
    {
        Image result = null;

        if (path == null)
        {
            Textures curTex = internalDefault[texId];
            if (curTex.texture == null)
            {
                path = "resources/gfx/" + curTex.name + ".png";
                curTex.texture = Utils.getImage(path, true);
            }
            result = curTex.texture;
        }
        else
        {
            if (texId != -1)
            {
                path += internalDefault[texId].name;
            }
            result = Utils.getImage(path + ".png", true);
            if (result == null)
            {
                result = Utils.getImage(path + ".jpg", true);
            }
        }

        return result;
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////

    public int id;
    public String name;
    public Image texture;

    private Textures(int _id, String _name)
    {
        id = _id;
        name = _name;
    }
}
