package oplutil;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JRootPane;
import javax.swing.KeyStroke;

import util.Utils;

public class GameDialog extends JDialog implements ActionListener
{
    public GameDialog(Main main)
    {
        super(main, "Game information", true);

        JRootPane rootPane = getRootPane();
        rootPane.setLayout(new BorderLayout());

        rootPane.add(main.getGamePanel(), BorderLayout.CENTER);

        JButton okButton = new JButton("Ok");
        okButton.addActionListener(this);
        rootPane.add(okButton, BorderLayout.SOUTH);

        KeyStroke stroke = KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0);
        rootPane.registerKeyboardAction(this, stroke, JComponent.WHEN_IN_FOCUSED_WINDOW);

        pack();

        okButton.requestFocusInWindow();
        Dimension maxSize = Utils.getDefaultSize();
        Dimension resultSize = getSize();
        resultSize.width = 400;

        if (resultSize.width < maxSize.width)
        {
            resultSize.width += 60;
        }
        if (resultSize.height < maxSize.height)
        {
            resultSize.height += 90;
        }

        setSize(resultSize);
        Utils.centerResizeWindow(this, false);
        setVisible(true);
        toFront();
    }

    @Override
    public void actionPerformed(ActionEvent e)
    {
        setVisible(false);
        dispose();
    }
}