package oplutil;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import opl.Config;

public class MenuBar extends JMenuBar implements ActionListener
{
    private static final long serialVersionUID = 1L;

    public JMenu menuActions, menuOptions;
    public JMenuItem itemDownloadArt, itemGameInfo, itemPreferences;
    public JCheckBoxMenuItem itemDisplayGamePanel;

    private Main main;

    public MenuBar(Main parent, boolean displayGamePanel)
    {
        super();
        main = parent;

        menuActions = new JMenu("Actions");
        menuActions.setMnemonic(KeyEvent.VK_A);
        add(menuActions);

        itemGameInfo = new JMenuItem("Game information", KeyEvent.VK_I);
        itemGameInfo.addActionListener(this);
        itemGameInfo.setEnabled(!displayGamePanel);
        //menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, ActionEvent.ALT_MASK));
        //menuItem.getAccessibleContext().setAccessibleDescription("This doesn't really do anything");
        menuActions.add(itemGameInfo);

        itemDownloadArt = new JMenuItem("Download Art", KeyEvent.VK_D);
        itemDownloadArt.addActionListener(this);
        menuActions.add(itemDownloadArt);

        menuOptions = new JMenu("Options");
        menuOptions.setMnemonic(KeyEvent.VK_O);
        add(menuOptions);

        itemDisplayGamePanel = new JCheckBoxMenuItem("display game info", false);
        itemDisplayGamePanel.addActionListener(this);
        itemDisplayGamePanel.setState(displayGamePanel);
        menuOptions.add(itemDisplayGamePanel);

        itemPreferences = new JMenuItem("Preferences", KeyEvent.VK_P);
        itemPreferences.addActionListener(this);
        menuOptions.add(itemPreferences);
    }

    public boolean displayGamePanelState()
    {
        return itemDisplayGamePanel.getState();
    }

    @Override
    public void actionPerformed(ActionEvent e)
    {
        Object source = e.getSource();
        if (source == itemDownloadArt)
        {
            for (int i = 3; i < 4; i++)
            {
                main.getMenu(i).fetchArt();
            }
        }
        else if (source == itemPreferences)
        {
            new SettingsDialog(main, "Preferences");
        }
        else if (source == itemGameInfo)
        {
            new GameDialog(main);
        }
        else if (source == itemDisplayGamePanel)
        {
            boolean state = itemDisplayGamePanel.getState();
            itemGameInfo.setEnabled(!state);
            main.toggleGamePanelState(state);
            itemDisplayGamePanel.setState(state);
            itemDisplayGamePanel.menuSelectionChanged(true);
            itemDisplayGamePanel.validate();
            main.getPrefs().setBoolean(Config.PREFS_DISPLAY_GAMEPANEL, state);
        }
    }
}
