package oplutil.device;

import esrpatcher.ESRStatus;

public class ItemBase implements Comparable<ItemBase>
{
    public static final String ART_COVER = "_COV";
    public static final String ART_ICON = "_ICO";
    public static final String ART_BACKGROUND = "_BG";

    public String name;
    public String startup;

    // only for games
    public byte media;
    public byte parts;
    public boolean isISO;
    
    public boolean isValid;
    public String leadingName;
    public String fullName;
    public ESRStatus esrStatus;
    public String realStartup;
    public int realParts;
    public long size;

    public ItemBase()
    {
        isValid = false;
        esrStatus = ESRStatus.ERROR_PATCHING;
    }

    public ItemBase(String _name, String _startup)
    {
        super();
        
        name = _name;
        startup = _startup;
    }

    @Override
    public int compareTo(ItemBase o)
    {
        return name.compareToIgnoreCase(o.name);
    }
}
