package util;

import java.io.InputStream;

import opl.Config;

import org.apache.commons.vfs.FileObject;
import org.apache.commons.vfs.impl.StandardFileSystemManager;

public class ISOSupport
{
    private static StandardFileSystemManager fsManager;

    static
    {
        try
        {
            fsManager = new StandardFileSystemManager();
            fsManager.init();
        }
        catch (Exception ex)
        {
            fsManager = null;
            ex.printStackTrace(System.err);
        }
    }

    public static String getStartup(String name)
    {
        String result = null;

        if (fsManager != null)
        {
            InputStream fis = null;
            try
            {
                FileObject isoFile = fsManager.resolveFile("iso://" + name + "!SYSTEM.CNF");
                fis = isoFile.getContent().getInputStream();
                Config content = new Config(fis, true);

                String boot = content.getString("BOOT2", null);
                if (boot != null)
                {
                    int backslash = boot.indexOf(':');
                    if (backslash != -1)
                    {
                        boot = boot.substring(backslash + 1, boot.length());
                    }
                    int comma = boot.indexOf(';');
                    if (comma != -1)
                    {
                        result = boot.substring(0, comma);
                    }
                }
            }
            catch (Exception ex)
            {
                ex.printStackTrace(System.err);
            }
            finally
            {
                try
                {
                    if (fis != null)
                    {
                        fis.close();
                    }
                }
                catch (Exception ex)
                {
                    ex.printStackTrace(System.err);
                }
            }
        }

        return result;
    }
}
